import scala.concurrent.{Future, Promise}
import scala.concurrent.ExecutionContext.Implicits.global
import robots._

def ex1 = { 
  val robotSwarm = List.range(1,6).map{i=> Robot(i,0,10)}
  val moved = robotSwarm.map(_.move(10))
  moved.map(_.onComplete(println))
  println("Started moving...")
}

def ex2 = { val r= Robot(99, 0, 20); for {
  r1 <- r.move(3)
  r2 <- r1.move(5)
  r3 <- r2.move(2)
  } yield r3 }

def ex3 = {
  val r= Robot(42,0,100)
  val p= Promise[Robot]()
  p.future.onComplete(println)
  val move= r.move2(20, p)  
  println("Started moving...")
}

